-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local bg = CreateFrame("Frame")
	bg:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
	bg:SetScript("OnEvent", function(bg, event, msg)
	local w = GetBattlefieldWinner() -- 0 wins horde // 1 wins alliance // 0 wins greens // 1 wins yellow
	local status, mapName, instanceID, bracketMin, bracketMax, teamSize, registeredMatch = GetBattlefieldStatus(1) -- registeredMatch 1 rankeds
	local fac = UnitFactionGroup("player")
	local numScores = GetNumBattlefieldScores()
	
	for n = 1, numScores do
		local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone, bgRating, ratingChange = GetBattlefieldScore(n)
		if event == "UPDATE_BATTLEFIELD_STATUS" then
			local _, type, _, _, _, _, _, _, _ = GetInstanceInfo()
			local d = 0

			if type == "pvp" and name == UnitName("player") and status == "active" then
			local d = 1

				if bgRating == 0 and (fac == "Horde" and w == 0) or (fac == "Alliance" and w == 1) then
					if d == 1 and mapName ~= nil then
						print("|cff00FF00+ Won |r" ..mapName.. "|cff00FF00 with |r" ..honorableKills.. "|cff00FF00 hkills.");
					end
				end
				if bgRating == 0 and (fac == "Horde" and w == 1) or (fac == "Alliance" and w == 0) then
					if d == 1 and mapName ~= nil then
						print("|cffFE2E2E- Lose |r" ..mapName.. "|cffFE2E2E with |r" ..honorableKills.. "|cffFE2E2E hkills.");
					end
				end
				if bgRating == 1 and (fac == "Horde" and w == 0) or (fac == "Alliance" and w == 1) then
					local rat = GetPersonalRatedInfo(4) --10v10
					local cr = (rat + ratingChange)
					if d == 1 and mapName ~= nil then
						print("|cff00FF00+ Won |r"..mapName.."|cff00FF00 @ |r"..rat.."|cff00FF00 + |r"..ratingChange.." = "..cr.." |cff00FF00cr rating.");
					end
				end
				if bgRating == 1 and (fac == "Horde" and w == 1) or (fac == "Alliance" and w == 0) then
					local rat = GetPersonalRatedInfo(4) --10v10
					local cr = (rat - ratingChange)
					if d == 1 and mapName ~= nil then
						print("|cffFE2E2E- Lose |r"..mapName.."|cffFE2E2E @ |r"..rat.."|cffFE2E2E - |r"..ratingChange.." = "..cr.." |cffFE2E2Ecr rating.");
					end
				end
				
			end
			
			--faction: 0 Green Team (Arena) / 1 Gold Team (Arena) w == 1 gold w == 0 green
			if type == "arena" and name == UnitName("player") and teamSize == "ARENASKIRMISH" and status == "active" then
			local d = 1

				if (faction == 1 and w == 1) or (faction == 0 and w == 0) then
					if d == 1 and mapName ~= nil then
			--			print("|cff00FF00+ Won |r"..mapName.." |cff00FF00unranked arena.")
					end
				end
				if (faction == 1 and w == 0) or (faction == 0 and w == 1) then
					if d == 1 and mapName ~= nil then
			--			print("|cffFE2E2E- Lose |r"..mapName.." |cffFE2E2Eunranked arena.")
					end
				end
				
			end
			
		end
	end
	
end)
--

local tam = {
	["TTTT"] = true,
}

local hem = {
	["TTTT"] = true,
}

local hes = { 
	["Discipline"] = true,
	["Restoration"] = true,
	["Mistweaver"] = true,
	["Holy"] = true,
}

local tas = { 
	["Brewmaster"] = true, -- monk
	["Protection"] = true, -- warrior, pala
	["Guardian"] = true, -- druid
	["Vengeance"] = true, -- dh
	["Blood"] = true, -- dk
}

local bh = CreateFrame("frame")
bh:RegisterEvent("PLAYER_LOGIN")
bh:RegisterEvent("NAME_PLATE_UNIT_ADDED")
bh:RegisterEvent("NAME_PLATE_UNIT_REMOVED")
bh:RegisterEvent("PLAYER_ENTERING_WORLD")
bh:RegisterEvent("UPDATE_BATTLEFIELD_SCORE")
bh:SetScript("OnEvent", function(self, event, ...) 
local inI, inT = IsInInstance()

		if event == "UPDATE_BATTLEFIELD_SCORE" then
		--local myFaction = GetBattlefieldArenaFaction()
			for i = 1, GetNumBattlefieldScores() do
				local player_name,_,_,_,_,_,_,_,_,_,_,_,_,_,_,spec = GetBattlefieldScore(i)
				if hes[spec] then
					hem[player_name] = true;
				else
					hem[player_name] = nil;
				end
				if tas[spec] then
					tam[player_name] = true;
				else
					tam[player_name] = nil;
				end
			end
		end
		if event == "NAME_PLATE_UNIT_ADDED" then
			local unitID = ...
			local tir = GetUnitName(unitID, true);
			local tat = GetUnitName(unitID, true);
		    if hem[tir] and inI and (inT == "pvp") and BangCharDB.Chk8 == true then
				local nal = C_NamePlate.GetNamePlateForUnit(unitID)
				if not nal.m then
					nal.m = nal:CreateTexture(nil, "OVERLAY")
					nal.m:SetTexture("Interface\\Icons\\Spell_chargepositive")
					nal.m:SetSize(32,32)
					nal.m:SetPoint("TOP", BangDB.bgMarksX, BangDB.bgMarksY) -- horizontal, vertical
				end
				nal.m:Show()
			end
		    if tam[tat] and inI and (inT == "pvp") and BangCharDB.Chk8 == true then
				local tna = C_NamePlate.GetNamePlateForUnit(unitID)
				if not tna.ma then
					tna.ma = tna:CreateTexture(nil, "OVERLAY")
					tna.ma:SetTexture("Interface\\Icons\\Ability_warrior_shieldmastery")
					tna.ma:SetSize(32,32)
					tna.ma:SetPoint("TOP", BangDB.bgMarksX, BangDB.bgMarksY) -- horizontal, vertical
				end
				tna.ma:Show()
			end
		elseif event == "NAME_PLATE_UNIT_REMOVED" then
			local unitID = ...
			local nal = C_NamePlate.GetNamePlateForUnit(unitID)
			local tna = C_NamePlate.GetNamePlateForUnit(unitID)
			if nal.m then 
				nal.m:Hide()
			end
			if tna.ma then 
				tna.ma:Hide()
			end
		end
	--end
end)
