-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local BB_Version = tonumber(GetAddOnMetadata("Bang_Bang", "Version"));
local BB_Intro = "|cffDDDDDDBang! Bang! is your best allied if you like the PvP, especially if you like world-PvP. This add-on gives you severals improvements and new features that will make you enjoy even more your battles."

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(self, event, ...)
 
    if event == "ADDON_LOADED" and ... == "Bang_Bang" then
        if not BangDB then BangDB = {} end
        if not BangKills then BangKills = {} end
        if not BangDeaths then BangDeaths = {} end
        if not BangHateds then BangHateds = {} end
		--
        if not BangCharDB then BangCharDB = {} end
        if not BangCharKills then BangCharKills = {} end
        if not BangCharDeaths then BangCharDeaths = {} end
        if not BangCharHateds then BangCharHateds = {} end

		self:UnregisterEvent("ADDON_LOADED");
	end

	if event == "PLAYER_LOGIN" then
		Bbui:Hide()
	-- DB
		if BangCharDB["Chk1"] == nil then BangCharDB["Chk1"] = true	end
		if BangCharDB["Chk2"] == nil then BangCharDB["Chk2"] = true	end
		if BangCharDB["Chk3"] == nil then BangCharDB["Chk3"] = true	end
		if BangCharDB["Chk4"] == nil then BangCharDB["Chk4"] = true	end
		if BangCharDB["Chk5"] == nil then BangCharDB["Chk5"] = true	end
		if BangCharDB["Chk6"] == nil then BangCharDB["Chk6"] = true	end
		if BangCharDB["Chk7"] == nil then BangCharDB["Chk7"] = true	end
		if BangCharDB["Chk8"] == nil then BangCharDB["Chk8"] = true	end
		--
		if BangDB["TITO"] == nil then BangDB["TITO"] = true	end
		if BangKills["TITO"] == nil then BangKills["TITO"] = 1 end
		if BangDeaths["TITO"] == nil then BangDeaths["TITO"] = 1 end
		if BangHateds["TITO"] == nil then BangHateds["TITO"] = true	end
		--
		if BangCharDB["TITO"] == nil then BangCharDB["TITO"] = true	end
		if BangCharKills["TITO"] == nil then BangCharKills["TITO"] = 1 end
		if BangCharDeaths["TITO"] == nil then BangCharDeaths["TITO"] = 1 end
		if BangCharHateds["TITO"] == nil then BangCharHateds["TITO"] = true	end
		
		if BangCharDB["walerterX"] == nil then BangCharDB["walerterX"] = 0 end
		if BangCharDB["walerterY"] == nil then BangCharDB["walerterY"] = -55 end
		if BangDB["bgMarksX"] == nil then BangDB["bgMarksX"] = 0 end
		if BangDB["bgMarksY"] == nil then BangDB["bgMarksY"] = 40 end
		if BangDB["wantedsX"] == nil then BangDB["wantedsX"] = 0 end
		if BangDB["wantedsY"] == nil then BangDB["wantedsY"] = 40 end
		
	end
	
	if (event == "PLAYER_ENTERING_WORLD") then
       if not IsAddOnLoaded("Blizzard_PVPUI") then
          LoadAddOn("Blizzard_PVPUI")
       end
       self:UnregisterEvent("PLAYER_ENTERING_WORLD")
    end
end)

-----------------------
-- GUI
-----------------------
local Bbui = CreateFrame("Frame", "Bbui", UIParent)
Bbui:SetSize(450,400)
Bbui:SetBackdrop( {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 20,
	edgeSize = 20,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
} )
Bbui:SetBackdropColor(.05, .05, .05, .95)
    Bbui:SetMovable(true)
    Bbui:SetUserPlaced(true)
    Bbui:RegisterForDrag("LeftButton")
    Bbui:EnableMouse(true)
    Bbui:SetScript("OnDragStart", function(self) Bbui:StartMoving() end)
    Bbui:SetScript("OnDragStop", function(self) Bbui:StopMovingOrSizing() end)
	Bbui:SetPoint("CENTER")
--
Bbui.title = CreateFrame("MessageFrame", nil, Bbui)
Bbui.title:SetSize(200,35)
Bbui.title:SetPoint("TOP",0,16)
Bbui.title:SetBackdrop( {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
--	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 20,
	edgeSize = 20,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
} )
Bbui.title:SetBackdropColor(0, 0, 0, 1)
	local text = Bbui.title:CreateFontString(nil, nil, 'GameFontHighlightLeft')
	text:SetPoint("CENTER"); text:SetJustifyH("CENTER"); text:SetWidth(200); text:SetHeight(35); text:SetSpacing(0)
	text:SetText("|cffFFD800Bang! Bang! "..BB_Version) -- color oro

--
Bbui.intro = CreateFrame("Frame", nil, Bbui)
Bbui.intro:SetSize(410,100)
Bbui.intro:SetPoint("TOP",0,-15)
--Bbui.intro:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
--Bbui.intro:SetBackdropColor(1, 0, 0, 1) -- para ver frame color
	local text = Bbui.intro:CreateFontString(nil, nil, 'GameFontHighlightLeft')
	text:SetPoint("TOPLEFT", 5, 20); text:SetWidth(410); text:SetHeight(100); text:SetSpacing(0)
	text:SetText(BB_Intro)
--
Bbui.author = CreateFrame("MessageFrame", nil, Bbui)
Bbui.author:SetSize(170,40)
Bbui.author:SetPoint("BOTTOM",130,10)
Bbui.author:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.author:SetFading(false)
Bbui.author:SetSpacing(0)
Bbui.author:AddMessage("Author:", .3, .3, .3, 1)
Bbui.author:AddMessage("Mortimer - Outland", .3, .3, .3, 1)

Bbui.author:SetJustifyH("RIGHT")
--
Bbui.f1f = CreateFrame("MessageFrame", nil, Bbui)
Bbui.f1f:SetSize(370,200)
Bbui.f1f:SetPoint("TOP", 0, -115)
Bbui.f1f:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Bbui.f1f:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Bbui.f1f.tab = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.tab:SetSize(120,20)
Bbui.f1f.tab:SetPoint("TOP", 115, -210)
Bbui.f1f.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.tab:SetFading(false)
Bbui.f1f.tab:AddMessage("Main", 1, .8, 0, 1) --color oro
Bbui.f1f.tab:SetJustifyH("RIGHT")
--
Bbui.f2f = CreateFrame("MessageFrame", nil, Bbui)
Bbui.f2f:SetSize(370,200)
Bbui.f2f:SetPoint("TOP", 0, -115)
Bbui.f2f:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Bbui.f2f:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Bbui.f2f.tab = CreateFrame("MessageFrame", nil, Bbui.f2f)
Bbui.f2f.tab:SetSize(120,20)
Bbui.f2f.tab:SetPoint("TOP", 115, -210)
Bbui.f2f.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f2f.tab:SetFading(false)
Bbui.f2f.tab:SetSpacing(0)
Bbui.f2f.tab:AddMessage("Config", 1, .8, 0, 1) --color oro
Bbui.f2f.tab:SetJustifyH("RIGHT")
--
Bbui.f2f.head = CreateFrame("SimpleHTML", nil, Bbui.f2f)
Bbui.f2f.head:SetSize(345,146)
Bbui.f2f.head:SetPoint("TOP", 0, 0)
Bbui.f2f.head:SetFont('Fonts\\FRIZQT__.TTF', 12);
Bbui.f2f.head:SetText("<html><body><p>|cffDDDDDDMark your own settings:</p></body></html>")
--
Bbui.f2f.foot = CreateFrame("SimpleHTML", nil, Bbui.f2f)
Bbui.f2f.foot:SetSize(340,35)
Bbui.f2f.foot:SetPoint("BOTTOMLEFT", 10, -15)
Bbui.f2f.foot:SetFont('Fonts\\FRIZQT__.TTF', 12);
Bbui.f2f.foot:SetText("<html><body><p>|cffDDDDDDContact us if have some suggestion.</p></body></html>")
--
Bbui.f2f.chk1 = CreateFrame("CheckButton", "chk1", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk1:ClearAllPoints()
Bbui.f2f.chk1:SetPoint("CENTER", -140, 50)
_G[Bbui.f2f.chk1:GetName() .. "Text"]:SetText("|cffDDDDDDSound when death")
Bbui.f2f.chk1:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk1 = true; print("|cffFFD800Sound when death |cff2EFE2EON");
	else 
		BangCharDB.Chk1 = false; print("|cffFFD800Sound when death |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk1:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk1) end)
--
Bbui.f2f.chk2 = CreateFrame("CheckButton", "chk2", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk2:ClearAllPoints()
Bbui.f2f.chk2:SetPoint("CENTER", -140, 20)
_G[Bbui.f2f.chk2:GetName() .. "Text"]:SetText("|cffDDDDDDSound when resurrect")
Bbui.f2f.chk2:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk2 = true; print("|cffFFD800Sound when resurrect |cff2EFE2EON");
	else 
		BangCharDB.Chk2 = false; print("|cffFFD800Sound when resurrect |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk2:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk2) end)
--
Bbui.f2f.chk3 = CreateFrame("CheckButton", "chk3", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk3:ClearAllPoints()
Bbui.f2f.chk3:SetPoint("CENTER", -140, -10)
_G[Bbui.f2f.chk3:GetName() .. "Text"]:SetText("|cffDDDDDDEmote when kill")
Bbui.f2f.chk3:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk3 = true; print("|cffFFD800Emote when kill |cff2EFE2EON");
	else 
		BangCharDB.Chk3 = false; print("|cffFFD800Emote when kill |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk3:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk3) end)
--
Bbui.f2f.chk4 = CreateFrame("CheckButton", "chk4", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk4:ClearAllPoints()
Bbui.f2f.chk4:SetPoint("CENTER", -140, -40)
_G[Bbui.f2f.chk4:GetName() .. "Text"]:SetText("|cffDDDDDDEmote when interrumpt")
Bbui.f2f.chk4:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk4 = true; print("|cffFFD800Emote when interrumpt |cff2EFE2EON");
	else 
		BangCharDB.Chk4 = false; print("|cffFFD800Emote when interrumpt |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk4:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk4) end)
--
Bbui.f2f.chk5 = CreateFrame("CheckButton", "chk5", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk5:ClearAllPoints()
Bbui.f2f.chk5:SetPoint("CENTER", 20, 50)
_G[Bbui.f2f.chk5:GetName() .. "Text"]:SetText("|cffDDDDDDStreak messages")
Bbui.f2f.chk5:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk5 = true; print("|cffFFD800Streak messages |cff2EFE2EON");
	else 
		BangCharDB.Chk5 = false; print("|cffFFD800Streak messages |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk5:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk5) end)
--
Bbui.f2f.chk6 = CreateFrame("CheckButton", "chk6", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk6:ClearAllPoints()
Bbui.f2f.chk6:SetPoint("CENTER", 20, 20)
_G[Bbui.f2f.chk6:GetName() .. "Text"]:SetText("|cffDDDDDDMedallion/racial alerter")
Bbui.f2f.chk6:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk6 = true; print("|cffFFD800Medallion or racial alerter |cff2EFE2EON");
	else 
		BangCharDB.Chk6 = false; print("|cffFFD800Medallion or racial alerter |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk6:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk6) end)
--
Bbui.f2f.chk7 = CreateFrame("CheckButton", "chk7", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk7:ClearAllPoints()
Bbui.f2f.chk7:SetPoint("CENTER", 20, -10)
_G[Bbui.f2f.chk7:GetName() .. "Text"]:SetText("|cffDDDDDDBG assist buttons")
Bbui.f2f.chk7:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk7 = true; print("|cffFFD800Battleground assist buttons |cff2EFE2EON");
	else 
		BangCharDB.Chk7 = false; print("|cffFFD800Battleground assist buttons |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk7:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk7) end)
--
Bbui.f2f.chk8 = CreateFrame("CheckButton", "chk8", Bbui.f2f, "UICheckButtonTemplate")
Bbui.f2f.chk8:ClearAllPoints()
Bbui.f2f.chk8:SetPoint("CENTER", 20, -40)
_G[Bbui.f2f.chk8:GetName() .. "Text"]:SetText("|cffDDDDDDBG tank/healer marks")
Bbui.f2f.chk8:SetScript("OnClick", function(self, event, ...)
	if self:GetChecked() then
		BangCharDB.Chk8 = true; print("|cffFFD800Battleground tank/healer marks |cff2EFE2EON");
	else 
		BangCharDB.Chk8 = false; print("|cffFFD800Battleground tank/healer marks |cffFE2E2EOFF");
	end
end)
Bbui.f2f.chk8:SetScript('OnShow', function(self) self:SetChecked(BangCharDB.Chk8) end)
--
Bbui.f3f = CreateFrame("MessageFrame", nil, Bbui)
Bbui.f3f:SetSize(370,200)
Bbui.f3f:SetPoint("TOP", 0, -115)
Bbui.f3f:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Bbui.f3f:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Bbui.f3f.tab = CreateFrame("MessageFrame", nil, Bbui.f3f)
Bbui.f3f.tab:SetSize(120,20)
Bbui.f3f.tab:SetPoint("TOP", 115, -210)
Bbui.f3f.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f3f.tab:SetFading(false)
Bbui.f3f.tab:AddMessage("Wanted List", 1, .8, 0, 1) --color oro
Bbui.f3f.tab:SetJustifyH("RIGHT")
--
Bbui.f3f.head = CreateFrame("SimpleHTML", nil, Bbui.f3f)
Bbui.f3f.head:SetSize(345,146)
Bbui.f3f.head:SetPoint("TOP", 0, 0)
Bbui.f3f.head:SetFont('Fonts\\FRIZQT__.TTF', 12)
Bbui.f3f.head:SetSpacing(0)
Bbui.f3f.head:SetText("<html><body><p>|cffDDDDDDWrite the name of your enemy and add him to your wanted list and find him more easy.</p></body></html>")
--
Bbui.f3f.type = CreateFrame("SimpleHTML", nil, Bbui.f3f)
Bbui.f3f.type:SetSize(200,35)
Bbui.f3f.type:SetPoint("CENTER", -45, 40)
Bbui.f3f.type:SetFont('Fonts\\FRIZQT__.TTF', 12);
Bbui.f3f.type:SetText("<html><body><p>|cff777777Use Name-Realm always</p></body></html>")
--
Bbui.f3f.foot = CreateFrame("SimpleHTML", nil, Bbui.f3f)
Bbui.f3f.foot:SetSize(360,35)
Bbui.f3f.foot:SetPoint("BOTTOMLEFT", 10, -15)
Bbui.f3f.foot:SetFont('Fonts\\FRIZQT__.TTF', 12);
Bbui.f3f.foot:SetText("<html><body><p>|cffDDDDDDRemember use Name-Realm for players, also can add mobs. Enjoy hunting!</p></body></html>")
--
Bbui.f3f.input = CreateFrame("EditBox", "addenemy", Bbui.f3f, 'InputBoxTemplate')
Bbui.f3f.input:SetSize(200,22)
Bbui.f3f.input:SetAutoFocus(false)
Bbui.f3f.input:SetMaxLetters(30)
Bbui.f3f.input:SetPoint("CENTER", -65, 30)
Bbui.f3f.input:SetScript('OnChar', function(self, addenemy)
    self:GetParent().addenemy = self:GetText()
end)
--
Bbui.f3f.add = CreateFrame("Button", "addenemy", Bbui.f3f, "UIPanelButtonTemplate")
Bbui.f3f.add:SetSize(50,22)
Bbui.f3f.add:SetPoint("CENTER", 70, 30)
Bbui.f3f.add:SetText("Add")
Bbui.f3f.add:SetScript("OnClick", function(self, addenemy)
	BangHateds[self:GetParent().addenemy] = true;
    print("|cff009900+ Added |r" ..self:GetParent().addenemy.." |cff009900to wanted list.")
	Bbui.f3f.input:SetText("")
end)
--
 Bbui.f3f.list = CreateFrame("Button", "delenemy", Bbui.f3f, "UIDropDownMenuTemplate")
 Bbui.f3f.list:SetPoint("CENTER", -35, -12)
--
Bbui.f3f.test = CreateFrame("Button", "addenemy", Bbui.f3f, "UIPanelButtonTemplate")
Bbui.f3f.test:SetSize(50,22)
Bbui.f3f.test:SetPoint("CENTER", 70, -50)
Bbui.f3f.test:SetText("Test")
Bbui.f3f.test:SetScript("OnClick", function(self, event, ...)
	HateList.a:AddMessage("|cffFE2E2EYour enemy |cffDDDDDDWanted-Name |cffFE2E2Eis near", .9, .9, .9, 1)
	HateList:Show()
end)
--
Bbui.f4f = CreateFrame("MessageFrame", nil, Bbui)
Bbui.f4f:SetSize(370,200)
Bbui.f4f:SetPoint("TOP", 0, -115)
Bbui.f4f:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
Bbui.f4f:SetBackdropColor(0, 0, 0, 1) -- para ver frame color
--
Bbui.f4f.tab = CreateFrame("MessageFrame", nil, Bbui.f4f)
Bbui.f4f.tab:SetSize(120,20)
Bbui.f4f.tab:SetPoint("TOP", 115, -210)
Bbui.f4f.tab:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f4f.tab:SetFading(false)
Bbui.f4f.tab:AddMessage("Credits", 1, .8, 0, 1) --color oro
Bbui.f4f.tab:SetJustifyH("RIGHT")
--
Bbui.f4f.head = CreateFrame("SimpleHTML", nil, Bbui.f4f)
Bbui.f4f.head:SetSize(345,146)
Bbui.f4f.head:SetPoint("TOP", 0, 0)
Bbui.f4f.head:SetFont('Fonts\\FRIZQT__.TTF', 12)
Bbui.f4f.head:SetSpacing(0)
Bbui.f4f.head:SetText("<html><body><p>|cffDDDDDDSpecial thanks to the following people for their assistance with this project:</p></body></html>")

Bbui.f4f.block = CreateFrame("SimpleHTML", nil, Bbui.f4f)
Bbui.f4f.block:SetSize(360,146)
Bbui.f4f.block:SetPoint("TOP", 10, -45)
Bbui.f4f.block:SetFont('Fonts\\FRIZQT__.TTF', 12)
Bbui.f4f.block:SetSpacing(0)
Bbui.f4f.block:SetText("<html><body><p>|cffFFD800Amenamaste - Outland  |cff555555beta tester</p><p>|cffFFD800Aurka - DunModr  |cff555555supp. streamer: twitch.com/aurkalol</p><p>|cffFFD800Drpewpew - DunModr  |cff555555translator</p><p>|cffFFD800Ryukek - TwistingNether  |cff555555beta tester</p><p>|cffFFD800Tito - Stormscale  |cff555555main assistant</p><p>|cffFFD800Woolfwood - Sanguino  |cff555555alpha tester</p></body></html>")
--Bbui.f4f.block:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",}) -- para ver frame
--Bbui.f4f.block:SetBackdropColor(1, 0, 0, 1) -- para ver frame color

Bbui.f4f.foot = CreateFrame("SimpleHTML", nil, Bbui.f4f)
Bbui.f4f.foot:SetSize(340,35)
Bbui.f4f.foot:SetPoint("BOTTOMLEFT", 10, -15)
Bbui.f4f.foot:SetFont('Fonts\\FRIZQT__.TTF', 12)
Bbui.f4f.foot:SetSpacing(0)
Bbui.f4f.foot:SetText("<html><body><p>|cffDDDDDDAlso thanks to all who use and support it.</p></body></html>")
--
Bbui.buttonC = CreateFrame("Button",nil,Bbui,"UIPanelButtonTemplate")
Bbui.buttonC:SetSize(75,22)
Bbui.buttonC:SetPoint("BOTTOM", 0, 20)
Bbui.buttonC:SetText("Close")
Bbui.buttonC:SetScript("OnClick", function()
		Bbui:Hide()
end)
--
Bbui.buttonBG = CreateFrame("Button",nil,Bbui,"UIPanelButtonTemplate")
Bbui.buttonBG:SetSize(75,22)
Bbui.buttonBG:SetPoint("BOTTOM", -40, 50)
Bbui.buttonBG:SetText("PvP Panel")
Bbui.buttonBG:SetScript("OnClick", function(self,event, ...)
		TogglePVPUI()
end)
--
Bbui.buttonBG = CreateFrame("Button",nil,Bbui,"UIPanelButtonTemplate")
Bbui.buttonBG:SetSize(75,22)
Bbui.buttonBG:SetPoint("BOTTOM", 40, 50)
Bbui.buttonBG:SetText("Reload UI")
Bbui.buttonBG:SetScript("OnClick", function(self,event, ...)
		ReloadUI()
end)
--
Bbui.action1 = CreateFrame("Button",nil,Bbui,"UIPanelButtonTemplate")
Bbui.action1:SetSize(75,22)
Bbui.action1:SetPoint("TOP", -120, -82)
Bbui.action1:SetText("Main")
Bbui.action1:SetScript("OnClick", function()
	Bbui.f1f:Show()
	Bbui.f2f:Hide()
	Bbui.f3f:Hide()
	Bbui.f4f:Hide()
end)
--
Bbui.action2 = CreateFrame("Button",nil,Bbui,"UIPanelButtonTemplate")
Bbui.action2:SetSize(75,22)
Bbui.action2:SetPoint("TOP", -40, -82)
Bbui.action2:SetText("Config")
Bbui.action2:SetScript("OnClick", function()
	Bbui.f1f:Hide()
	Bbui.f2f:Show()
	Bbui.f3f:Hide()
	Bbui.f4f:Hide()
end)
--
Bbui.action3 = CreateFrame("Button",nil,Bbui,"UIPanelButtonTemplate")
Bbui.action3:SetSize(75,22)
Bbui.action3:SetPoint("TOP", 40, -82)
Bbui.action3:SetText("Wanted")
Bbui.action3:SetScript("OnClick", function()
	Bbui.f1f:Hide()
	Bbui.f2f:Hide()
	Bbui.f3f:Show()
	Bbui.f4f:Hide()
end)
--
Bbui.action4 = CreateFrame("Button",nil,Bbui,"UIPanelButtonTemplate")
Bbui.action4:SetSize(75,22)
Bbui.action4:SetPoint("TOP", 120, -82)
Bbui.action4:SetText("Credits")
Bbui.action4:SetScript("OnClick", function()
	Bbui.f1f:Hide()
	Bbui.f2f:Hide()
	Bbui.f3f:Hide()
	Bbui.f4f:Show()
end)

local b = CreateFrame("FRAME");
b:RegisterEvent("ADDON_LOADED");
b:RegisterEvent("PLAYER_ENTERING_WORLD");
 
local function eventHandler(self, event, ...)

-- CONTENIDO SELECTOR WANTED LIST
local function OnSelect(self)
	UIDropDownMenu_SetSelectedID(delenemy, self:GetID())
	bbang_ddelenemy = self:GetText()
end

local function initialize(self, level)
local toSort = {}
for k in pairs(BangHateds) do toSort[#toSort + 1] = k end
table.sort(toSort)
--for i = 1, #toSort do print(toSort[i]) end

local info=UIDropDownMenu_CreateInfo()
    for k,v in pairs(toSort) do
		info=UIDropDownMenu_CreateInfo()
		info.text=v
		info.value=v
		info.func=OnSelect
		UIDropDownMenu_AddButton(info, level)
    end
end

local function Init(delenemy)
    UIDropDownMenu_Initialize(delenemy, initialize)
    UIDropDownMenu_SetWidth(delenemy, 120)
    UIDropDownMenu_SetButtonWidth(delenemy, 124)
    UIDropDownMenu_SetSelectedID(delenemy, 1)
	UIDropDownMenu_JustifyText(delenemy, "LEFT")
end

Bbui.f3f.del = CreateFrame("Button", "delenemy", Bbui.f3f, "UIPanelButtonTemplate")
Bbui.f3f.del:SetSize(50,22)
Bbui.f3f.del:SetPoint("CENTER", 70, -10)
Bbui.f3f.del:SetText("Del")
Bbui.f3f.del:SetScript("OnClick", function(self)
	BangHateds[bbang_ddelenemy] = nil;
	print("|cffFE2E2E- Deleted |r" ..bbang_ddelenemy.." |cffFE2E2Efrom wanted list.")
	Init(delenemy) -- hace reload al listado despues de borrar

end)
Init(delenemy) -- nombre frames

-- SORT TABLE BY KILLS
local function spairs(BangKills, order)
    local tkills = {}
    for k in pairs(BangKills) do tkills[#tkills + 1] = k end
    if order then
   -- if order then
        table.sort(tkills, function(a,b) return order(BangKills, a, b) end)
    else
        table.sort(tkills)
    end
    local i = 0
    return function()
        i = i + 1
Bbui.f1f.topkills2 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.topkills2:SetSize(50,100)
Bbui.f1f.topkills2:SetPoint("TOP", -60, -40)
Bbui.f1f.topkills2:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.topkills2:SetFading(false)
Bbui.f1f.topkills2:SetSpacing(0)
Bbui.f1f.topkills2:SetJustifyH("CENTER")
Bbui.f1f.topkills2:AddMessage("BANGS", 1, .8, 0, 1)
        if tkills[1] then
			Bbui.f1f.topkills2:AddMessage(BangKills[tkills[1]], 0, .8, 0, 1)
		else
			Bbui.f1f.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
        if tkills[2] then
			Bbui.f1f.topkills2:AddMessage(BangKills[tkills[2]], 0, .8, 0, 1)
		else
			Bbui.f1f.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
        if tkills[3] then
			Bbui.f1f.topkills2:AddMessage(BangKills[tkills[3]], 0, .8, 0, 1)
		else
			Bbui.f1f.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
		if tkills[4] then
			Bbui.f1f.topkills2:AddMessage(BangKills[tkills[4]], 0, .8, 0, 1)
		else
			Bbui.f1f.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
		if tkills[5] then
			Bbui.f1f.topkills2:AddMessage(BangKills[tkills[5]], 0, .8, 0, 1)
		else
			Bbui.f1f.topkills2:AddMessage("0", 0, .8, 0, 1)
        end
Bbui.f1f.topkills3 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.topkills3:SetSize(250,100)
Bbui.f1f.topkills3:SetPoint("TOP", 165, -40)
Bbui.f1f.topkills3:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.topkills3:SetFading(false)
Bbui.f1f.topkills3:SetSpacing(0)
Bbui.f1f.topkills3:SetJustifyH("LEFT")
--
Bbui.f1f.topkills3:AddMessage("NAME", 1, .8, 0, 1)
        if tkills[1] then
			Bbui.f1f.topkills3:AddMessage(tkills[1], 1, 1, 1, 1)
		else
			Bbui.f1f.topkills3:AddMessage("0", 1, 1, .1, 1)
        end
        if tkills[2] then
			Bbui.f1f.topkills3:AddMessage(tkills[2], .9, .9, .9, 1)
		else
			Bbui.f1f.topkills3:AddMessage("0", 9, .9, .9, 1)
        end
        if tkills[3] then
			Bbui.f1f.topkills3:AddMessage(tkills[3], .7, .7, .7, 1)
		else
			Bbui.f1f.topkills3:AddMessage("0", 7, .7, .7, 1)
        end
		if tkills[4] then
			Bbui.f1f.topkills3:AddMessage(tkills[4], .6, .6, .6, 1)
		else
			Bbui.f1f.topkills3:AddMessage("0", .6, .6, .6, 1)
        end
		if tkills[5] then
			Bbui.f1f.topkills3:AddMessage(tkills[5], .5, .5, .5, 1)
		else
			Bbui.f1f.topkills3:AddMessage("0", .5, .5, .5, 1)
        end
Bbui.f1f.topkills4 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.topkills4:SetSize(50,100)
Bbui.f1f.topkills4:SetPoint("TOP", 0, -40)
Bbui.f1f.topkills4:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.topkills4:SetFading(false)
Bbui.f1f.topkills4:SetSpacing(0)
Bbui.f1f.topkills4:SetJustifyH("CENTER")
Bbui.f1f.topkills4:AddMessage("DEATHS", 1, .8, 0, 1)
        if BangDeaths[tkills[1]] then
			Bbui.f1f.topkills4:AddMessage(BangDeaths[tkills[1]], .8, 0, 0, 1)
		else
			Bbui.f1f.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[2]] then
		Bbui.f1f.topkills4:AddMessage(BangDeaths[tkills[2]], .8, 0, 0, 1)
		else
			Bbui.f1f.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[3]] then
		Bbui.f1f.topkills4:AddMessage(BangDeaths[tkills[3]], .8, 0, 0, 1)
		else
			Bbui.f1f.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[4]] then
		Bbui.f1f.topkills4:AddMessage(BangDeaths[tkills[4]], .8, 0, 0, 1)
		else
			Bbui.f1f.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
        if BangDeaths[tkills[5]] then
		Bbui.f1f.topkills4:AddMessage(BangDeaths[tkills[5]], .8, .0, .0, 1)
		else
			Bbui.f1f.topkills4:AddMessage("0", .8, 0, 0, 1)
        end
	end
end

for k,v in spairs(BangKills, function(BangKills,a,b) return BangKills[b] < BangKills[a] end) do end -- prints tabla tops

Bbui.f1f.topkills1 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.topkills1:SetSize(50,100)
Bbui.f1f.topkills1:SetPoint("TOP", -110, -40)
Bbui.f1f.topkills1:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.topkills1:SetFading(false)
Bbui.f1f.topkills1:SetSpacing(0)
Bbui.f1f.topkills1:SetJustifyH("CENTER")
Bbui.f1f.topkills1:AddMessage("TOP ", 1, .8, 0, 1)
Bbui.f1f.topkills1:AddMessage("#1", 1, .7, .05, 1)
Bbui.f1f.topkills1:AddMessage("#2", .8, .8, .8, 1)
Bbui.f1f.topkills1:AddMessage("#3", .6, .35, 0, 1)
Bbui.f1f.topkills1:AddMessage("#4", .6, .6, .6, 1)
Bbui.f1f.topkills1:AddMessage("#5", .5, .5, .5, 1)

-- BRUTAL
--local toSort = {}
--for k in pairs(BangHateds) do toSort[#toSort + 1] = k end
--table.sort(toSort)
--for i = 1, #toSort do print(toSort[i]) end
--

end
b:SetScript("OnEvent", eventHandler);
--



function bangBraks()
local r, _, _, _, s = GetPersonalRatedInfo(1) --2v2
local rr, _, _, _, ss = GetPersonalRatedInfo(2) --3v3
local rrr, _, _, _, sss = GetPersonalRatedInfo(4) --10v10

Bbui.f1f.rankt = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.rankt:SetSize(70,80)
Bbui.f1f.rankt:SetPoint("BOTTOM", -60, 0)
Bbui.f1f.rankt:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.rankt:SetFading(false)
Bbui.f1f.rankt:SetSpacing(0)
Bbui.f1f.rankt:AddMessage("BRACKET",  1, .8, 0, 1)
Bbui.f1f.rankt:AddMessage("2v2", .8, .8, .8, 1)
Bbui.f1f.rankt:AddMessage("3v3", .9, .9, .9, 1)
Bbui.f1f.rankt:AddMessage("10v10", .8, .8, .8, 1)
Bbui.f1f.rankt:SetJustifyH("RIGHT")

Bbui.f1f.rankw = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.rankw:SetSize(50,80)
Bbui.f1f.rankw:SetPoint("BOTTOM", 0, 0)
Bbui.f1f.rankw:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.rankw:SetFading(false)
Bbui.f1f.rankw:SetSpacing(0)
Bbui.f1f.rankw:SetJustifyH("CENTER")
Bbui.f1f.rankw:AddMessage("WINS",  1, .8, 0, 1)
Bbui.f1f.rankw:AddMessage(s, .8, .8, .8, 1)-------------------------------------------------------------------------------------------------
Bbui.f1f.rankw:AddMessage(ss, .9, .9, .9, 1)
Bbui.f1f.rankw:AddMessage(sss, .8, .8, .8, 1)

Bbui.f1f.rankr = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.rankr:SetSize(50,80)
Bbui.f1f.rankr:SetPoint("BOTTOM", 55, 0)
Bbui.f1f.rankr:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.rankr:SetFading(false)
Bbui.f1f.rankr:SetSpacing(0)
Bbui.f1f.rankr:SetJustifyH("LEFT")
Bbui.f1f.rankr:AddMessage("RATING",  1, .8, 0, 1)
Bbui.f1f.rankr:AddMessage(r, .8, .8, .8, 1)
Bbui.f1f.rankr:AddMessage(rr, .9, .9, .9, 1)
Bbui.f1f.rankr:AddMessage(rrr, .8, .8, .8, 1)

end


function banghTops()
	local names = {}
	local numbers = {}
	 
	for char_name,number_of_kills in pairs(BangKills) do
		if BangHateds[char_name] then
			if not names[number_of_kills] then
				numbers[#numbers+1] = number_of_kills
				names[number_of_kills] = {char_name}
			else
				names[number_of_kills][#names[number_of_kills]+1] = char_name
			end
		end
	end

table.sort(numbers, function(a,b)
	return b < a
end)

for i=1,1, -1 do
for j=1,1 do

	--foreach(numbers, print)
Bbui.f1f.htopkills1 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.htopkills1:SetSize(50,100)
Bbui.f1f.htopkills1:SetPoint("TOP", -110, 40)
Bbui.f1f.htopkills1:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.htopkills1:SetFading(false)
Bbui.f1f.htopkills1:SetSpacing(0)
Bbui.f1f.htopkills1:SetJustifyH("CENTER")
Bbui.f1f.htopkills1:AddMessage("TOP ", 1, .8, 0, 1)
Bbui.f1f.htopkills1:AddMessage("#1", 1, .7, .05, 1)
Bbui.f1f.htopkills1:AddMessage("#2", .65, .65, .65, 1)
Bbui.f1f.htopkills1:AddMessage("#3", .6, .35, 0, 1)
--
Bbui.f1f.htopkills2 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.htopkills2:SetSize(50,100)
Bbui.f1f.htopkills2:SetPoint("TOP", -60, 40)
Bbui.f1f.htopkills2:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.htopkills2:SetFading(false)
Bbui.f1f.htopkills2:SetSpacing(0)
Bbui.f1f.htopkills2:SetJustifyH("CENTER")
Bbui.f1f.htopkills2:AddMessage("BANGS", 1, .8, 0, 1)
        if numbers[1] then
			Bbui.f1f.htopkills2:AddMessage(numbers[1], 0, .8, 0, 1)
		else
			Bbui.f1f.htopkills2:AddMessage("0", 0, .8, 0, 1)
		end
		if numbers[2] then
			Bbui.f1f.htopkills2:AddMessage(numbers[2], 0, .8, 0, 1)
		else
			Bbui.f1f.htopkills2:AddMessage("0", 0, .8, 0, 1)
		end
        if numbers[3] then
			Bbui.f1f.htopkills2:AddMessage(numbers[3], 0, .8, 0, 1)
		else
			Bbui.f1f.htopkills2:AddMessage("0", 0, .8, 0, 1)
		end
--
Bbui.f1f.htopkills3 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.htopkills3:SetSize(50,100)
Bbui.f1f.htopkills3:SetPoint("TOP", 0, 40)
Bbui.f1f.htopkills3:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.htopkills3:SetFading(false)
Bbui.f1f.htopkills3:SetSpacing(0)
Bbui.f1f.htopkills3:SetJustifyH("CENTER")
Bbui.f1f.htopkills3:AddMessage("DEATHS", 1, .8, 0, 1)
        if BangDeaths[names[numbers[1]][j]] then
			Bbui.f1f.htopkills3:AddMessage(BangDeaths[names[numbers[1]][j]], .8, 0, 0, 1)
		else
			Bbui.f1f.htopkills3:AddMessage("0", .8, 0, 0, 1)
		end
        if BangDeaths[names[numbers[2]][j]] then
			Bbui.f1f.htopkills3:AddMessage(BangDeaths[names[numbers[2]][j]], .8, 0, 0, 1)
		else
			Bbui.f1f.htopkills3:AddMessage("0", .8, 0, 0, 1)
		end
        if BangDeaths[names[numbers[3]][j]] then
			Bbui.f1f.htopkills3:AddMessage(BangDeaths[names[numbers[3]][j]], .8, 0, 0, 1)
		else
			Bbui.f1f.htopkills3:AddMessage("0", .8, 0, 0, 1)
		end
--
Bbui.f1f.htopkills4 = CreateFrame("MessageFrame", nil, Bbui.f1f)
Bbui.f1f.htopkills4:SetSize(250,100)
Bbui.f1f.htopkills4:SetPoint("TOP", 165, 40)
Bbui.f1f.htopkills4:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
Bbui.f1f.htopkills4:SetFading(false)
Bbui.f1f.htopkills4:SetSpacing(0)
Bbui.f1f.htopkills4:SetJustifyH("LEFT")
Bbui.f1f.htopkills4:AddMessage("WANTED NAME", 1, .8, 0, 1)
        if names[numbers[1]][j] then
			Bbui.f1f.htopkills4:AddMessage(names[numbers[1]][j], .9, .9, .9, 1)
		else
			Bbui.f1f.htopkills4:AddMessage("0", .9, .9, .9, 1)
		end
		if names[numbers[2]][j] then
			Bbui.f1f.htopkills4:AddMessage(names[numbers[2]][j], .7, .7, .7, 1)
		else
			Bbui.f1f.htopkills4:AddMessage("0", .7, .7, .7, 1)
		end
        if names[numbers[3]][j] then
			Bbui.f1f.htopkills4:AddMessage(names[numbers[3]][j], .6, .6, .6, 1)
		else
			Bbui.f1f.htopkills4:AddMessage("0", .6, .6, .6, 1)
		end
end
end
end

